# ember-cli-typescript

This guide is designed to help you get up and running with TypeScript in an Ember app.

{% hint style="warning" %}

**This is _not_ an introduction to TypeScript _or_ Ember. Throughout this guide, we’ll link back to [the TypeScript docs](https://www.typescriptlang.org/docs/home.html) and [the Ember Guides](https://guides.emberjs.com/release/) when there are specific concepts that we will not explain here but which are important for understanding what we’re covering!**

{% endhint %}

To get started, check out the instructions in [Getting Started: Installation](./installation.md)

* If you're totally new to using TypeScript with Ember, start with [TypeScript and Ember](./ts/README.md).
* Once you have a good handle on the basics, you can dive into the guides to working with the APIs specific to [Ember](./ember/README.md) and [Ember Data](./ember-data/README.md).
* If you're working with legacy (pre-Octane) Ember and TypeScript together, you should read [the Legacy Guide](./legacy/README.md).
* Looking for type-checking in Glimmer templates? Check out [Glint](https://typed-ember.gitbook.io/glint/).

## Why TypeScript?

What is TypeScript, and why should you adopt it?

> TypeScript is a typed superset of JavaScript that compiles to plain JavaScript.  
> —[typescriptlang.org](http://www.typescriptlang.org)

TypeScript lets you build _ambitious web applications_ with confidence—so it’s a perfect fit for Ember apps!

* Get rid of `undefined is not a function` and `null is not an object` once and for all.
* Enjoy API docs… that are always up-to-date.
* Experience better developer productivity through top-notch editor support, including incredible autocomplete, guided refactorings, automatic imports, and more.

